"""
    Algorithmia Management APIs

    APIs for managing actions on the Algorithmia platform  # noqa: E501

    The version of the OpenAPI document: 1.5.0
    Contact: support@algorithmia.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from algorithmia_api_client.api_client import ApiClient, Endpoint as _Endpoint
from algorithmia_api_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from algorithmia_api_client.model.algorithm_usage_result import AlgorithmUsageResult
from algorithmia_api_client.model.full_usage_result import FullUsageResult
from algorithmia_api_client.model.inline_response500 import InlineResponse500
from algorithmia_api_client.model.user_usage_result import UserUsageResult


class UsageApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __get_algorithm_usage_result(
            self,
            start_date,
            end_date,
            page_size,
            **kwargs
        ):
            """Get algorithm usage information  # noqa: E501

            Returns usage information for a given date range. Paginated.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_algorithm_usage_result(start_date, end_date, page_size, async_req=True)
            >>> result = thread.get()

            Args:
                start_date (datetime): start date of query range in UTC format (2021-03-22T00:00:00.000Z)
                end_date (datetime): end date of query range in UTC format (2021-03-22T00:00:00.000Z)
                page_size (int): maximum number of results to return in one query

            Keyword Args:
                user ([str]): user or organization names. [optional]
                marker (str): Encoded pagination cursor. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                AlgorithmUsageResult
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['start_date'] = \
                start_date
            kwargs['end_date'] = \
                end_date
            kwargs['page_size'] = \
                page_size
            return self.call_with_http_info(**kwargs)

        self.get_algorithm_usage_result = _Endpoint(
            settings={
                'response_type': (AlgorithmUsageResult,),
                'auth': [],
                'endpoint_path': '/v1/admin/usage/algorithms',
                'operation_id': 'get_algorithm_usage_result',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'start_date',
                    'end_date',
                    'page_size',
                    'user',
                    'marker',
                ],
                'required': [
                    'start_date',
                    'end_date',
                    'page_size',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'start_date':
                        (datetime,),
                    'end_date':
                        (datetime,),
                    'page_size':
                        (int,),
                    'user':
                        ([str],),
                    'marker':
                        (str,),
                },
                'attribute_map': {
                    'start_date': 'start_date',
                    'end_date': 'end_date',
                    'page_size': 'page_size',
                    'user': 'user',
                    'marker': 'marker',
                },
                'location_map': {
                    'start_date': 'query',
                    'end_date': 'query',
                    'page_size': 'query',
                    'user': 'query',
                    'marker': 'query',
                },
                'collection_format_map': {
                    'user': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_algorithm_usage_result
        )

        def __get_full_usage(
            self,
            start_date,
            end_date,
            page_size,
            **kwargs
        ):
            """Get usage information  # noqa: E501

            Returns usage information for a given date range. Paginated.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_full_usage(start_date, end_date, page_size, async_req=True)
            >>> result = thread.get()

            Args:
                start_date (datetime): start date of query range in UTC format (2021-03-22T00:00:00.000Z)
                end_date (datetime): end date of query range in UTC format (2021-03-22T00:00:00.000Z)
                page_size (int): maximum number of results to return in one query

            Keyword Args:
                user ([str]): user or organization names. [optional]
                marker (str): Encoded pagination cursor. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                FullUsageResult
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['start_date'] = \
                start_date
            kwargs['end_date'] = \
                end_date
            kwargs['page_size'] = \
                page_size
            return self.call_with_http_info(**kwargs)

        self.get_full_usage = _Endpoint(
            settings={
                'response_type': (FullUsageResult,),
                'auth': [],
                'endpoint_path': '/v1/admin/usage',
                'operation_id': 'get_full_usage',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'start_date',
                    'end_date',
                    'page_size',
                    'user',
                    'marker',
                ],
                'required': [
                    'start_date',
                    'end_date',
                    'page_size',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'start_date':
                        (datetime,),
                    'end_date':
                        (datetime,),
                    'page_size':
                        (int,),
                    'user':
                        ([str],),
                    'marker':
                        (str,),
                },
                'attribute_map': {
                    'start_date': 'start_date',
                    'end_date': 'end_date',
                    'page_size': 'page_size',
                    'user': 'user',
                    'marker': 'marker',
                },
                'location_map': {
                    'start_date': 'query',
                    'end_date': 'query',
                    'page_size': 'query',
                    'user': 'query',
                    'marker': 'query',
                },
                'collection_format_map': {
                    'user': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_full_usage
        )

        def __get_user_usage_result(
            self,
            start_date,
            end_date,
            page_size,
            **kwargs
        ):
            """Get usage information grouped by user  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_user_usage_result(start_date, end_date, page_size, async_req=True)
            >>> result = thread.get()

            Args:
                start_date (datetime): start date of query range in UTC format (2021-03-22T00:00:00.000Z)
                end_date (datetime): end date of query range in UTC format (2021-03-22T00:00:00.000Z)
                page_size (int): maximum number of results to return in one query

            Keyword Args:
                user ([str]): user or organization names. [optional]
                marker (str): Encoded pagination cursor. [optional]
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                UserUsageResult
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['start_date'] = \
                start_date
            kwargs['end_date'] = \
                end_date
            kwargs['page_size'] = \
                page_size
            return self.call_with_http_info(**kwargs)

        self.get_user_usage_result = _Endpoint(
            settings={
                'response_type': (UserUsageResult,),
                'auth': [],
                'endpoint_path': '/v1/admin/usage/users',
                'operation_id': 'get_user_usage_result',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'start_date',
                    'end_date',
                    'page_size',
                    'user',
                    'marker',
                ],
                'required': [
                    'start_date',
                    'end_date',
                    'page_size',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'start_date':
                        (datetime,),
                    'end_date':
                        (datetime,),
                    'page_size':
                        (int,),
                    'user':
                        ([str],),
                    'marker':
                        (str,),
                },
                'attribute_map': {
                    'start_date': 'start_date',
                    'end_date': 'end_date',
                    'page_size': 'page_size',
                    'user': 'user',
                    'marker': 'marker',
                },
                'location_map': {
                    'start_date': 'query',
                    'end_date': 'query',
                    'page_size': 'query',
                    'user': 'query',
                    'marker': 'query',
                },
                'collection_format_map': {
                    'user': 'multi',
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_user_usage_result
        )
